.\" @(#)$RCSfile: lcg-lg.man,v $ $Revision: 1.12 $ $Date: 2009/11/19 13:58:41 $ CERN Jean-Philippe Baud
.\" Copyright (C) 2005 by CERN
.\" All rights reserved
.\"
.TH LCG-LG 1 "$Date: 2009/11/19 13:58:41 $" LCG_UTIL "User Commands"

.SH NAME
lcg-lg \- get the GUID for a given LFN or SURL

.SH SYNOPSIS
.B lcg-lg
[
.BI --config " config_file"
] [
.B -h,--help
] [
.B -b,--nobdii
] [
.B -v,--verbose
] [
.B  --connect-timeout "timeout"
] [
.B  --sendreceive-timeout "timeout"
] [
.B  --bdii-timeout "timeout"
] [
.BI --vo " virtual_organization"
] [
.B -v,--version
]
.I lfn_or_surl

.SH DESCRIPTION
.B lcg-lg
gets the GUID for a given LFN or SURL.
The program prints the actual GUID on stdout.
If you specify a given command line option
multiple times, the command takes into account only the very last one so that in a script, you can
override a particular option in a pre-set option set (like gcc does).
.TP
.I lfn_or_surl
specifies the Logical File Name or the Site URL. An SURL scheme can be
.B sfn:
for a classical SE or
.BR srm: .
.TP
.B --connect-timeout
Sets the connect timeout, used when connecting to a remote host. The connection will be aborted
if the remote host doesn't reply after
.I value
seconds. Default: 60 seconds.
.TP
.B --sendreceive-timeout
Sets the send/receive data timeout, used when transferring data to/from a remote host. The connection will be aborted
if no data is transfered after
.I value
seconds. Default: 0 (blocking).
.TP
.B --bdii-timeout
Sets the BDII timeout, used when searching information into BDII. The connection will be aborted
if the search is longer than
.I value
seconds. Default: 60 seconds.
.TP
.I vo
specifies the Virtual Organization the user belongs to. If it is not specified,
the environment variable LCG_GFAL_VO will be used.
.TP
.I conf_file
This argument is currently ignored.
.TP
.B -b,--nobdii
If this flag is present, it means that you don't want to make BDII calls to get SE type. So, you must provide the type of the SE
for srm: arguments, and full endpoint in SURLs. For SE type,
.I defaulttype
can be used (it will be used for both source and destination).
.TP
.B -v,--verbose
Verbose mode. You can specify it twice for extra verbose mode.

.SH NOTE
The environment variable LCG_GFAL_INFOSYS must point to the BDII, unless
.I --nobdii
option is used.
To use the RLS as catalog instead of the LFC, the environment variable
LCG_CATALOG_TYPE must explicitely be set to "edg". By default, it is set to "lfc".

.SH EXAMPLE
.nf
.ft CW
	lcg-lg --vo dteam lfn:/grid/dteam/tests/testjpb_rf10

	guid:b0f64a56-0f1e-4ed2-993e-631de0bd06bb
.ft
.fi

.SH EXIT STATUS
This program returns 0 if the operation was successful or >0 if the operation
failed.

.SH SEE ALSO
.BR lcg-aa (1),
.BR lcg-cp (1),
.BR lcg-cr (1),
.BR lcg-del (1),
.BR lcg-getturls (1),
.BR lcg-gt (1),
.BR lcg-la (1),
.BR lcg-lg (1),
.BR lcg-lr (1),
.BR lcg-ls (1),
.BR lcg-ra (1),
.BR lcg-rep (1),
.BR lcg-rf (1),
.BR lcg-sd (1),
.BR lcg-stmd (1),
.BR lcg-uf (1)
