.\" @(#)$RCSfile: lcg-ls.man,v $ $Revision: 1.10 $ $Date: 2009/11/19 13:58:41 $ CERN Remi Mollon
.\" Copyright (C) 2005 by CERN
.\" All rights reserved
.\"
.TH "LCG-LS" "1" "$Date: 2009/11/19 13:58:41 $" "LCG_UTIL" "User Commands"

.SH "NAME"
lcg-ls - list file information for given SURLs or LFNs

.SH "SYNOPSIS"
.B lcg-ls
[
.B -h,--help
] [
.B -v,--verbose
] [
.B  --connect-timeout "timeout"
] [
.B  --sendreceive-timeout "timeout"
] [
.B  --bdii-timeout "timeout"
] [
.B  --srm-timeout "timeout"
] [
.BI -D,--defaultsetype " defaulttype"
] [
.BI -T,--setype " setype"
] [
.B -b,--nobdii
] [
.B -l,--long
] [
.B -c,--count
] [
.B -o,--offset
] [
.B -d,--dir
] [
.BI --vo " virtual_organization"
] [
.B --version
]
.I file [...]

.SH "DESCRIPTION"
.B lcg-ls
lists the directory contents. If you specify a given command line option
multiple times, the command takes into account only the very last one so that in a script, you can
override a particular option in a pre-set option set (like gcc does).
.TP
.B --connect-timeout
Sets the connect timeout, used when connecting to a remote host. The connection will be aborted
if the remote host doesn't reply after
.I value
seconds. Default: 60 seconds.
.TP
.B --sendreceive-timeout
Sets the send/receive data timeout, used when transferring data to/from a remote host. The connection will be aborted
if no data is transfered after
.I value
seconds. Default: 0 (blocking).
.TP
.B --bdii-timeout
Sets the BDII timeout, used when searching information into BDII. The connection will be aborted
if the search is longer than
.I value
seconds. Default: 60 seconds.
.TP
.B --srm-timeout
Sets the SRM timeout, used when doing an asynchronous SRM request. The request will be aborted
if it is still queued after
.I value
seconds. Default: 3600 seconds (1 hour).
.TP
.I file
Can be a SURL or a LFN. Note that all files must have the same type (SURL, LFN), and in case of SURLs,
they have to be from the same SRM endpoint (the request will be sent to the SRM endpoint of the first SURL).
A SURL scheme can be
.B sfn:
for a classical SE or
.BR srm: .
.TP
.I defaulttype
specifies the default SE type you want to use. Possible values are
.BR none ,
.BR se ,
.BR srmv1 ,
.BR srmv2 ,
for respectively no default type, classic SE, SRMv1, and SRMv2. But if according to the BDII the default type
is not available for this SE, it will use another type.
.TP
.I setype
specifies the SE type you want to use. Possible values are
.BR none ,
.BR se ,
.BR srmv1 ,
.BR srmv2 ,
for respectively no type, classic SE, SRMv1, and SRMv2. But if according to the BDII the default type
is not available for this SE, it will fail.
.TP
.B -b,--nobdii
If this flag is present, it means that you don't want to make BDII calls to get SE type. So, you must provide the type of the SE
for srm: arguments, and full endpoint in SURLs. For SE type,
.I defaulttype
can be used.
.TP
.B -c,--count
Ignored if the file is not an SRM. List "count" number of files only. Using with "offset", you can retrieve long list of
files in chunks.
.TP
.B -o,--offset
Ignored if the file is not an SRM. Skip the first "offset" number of files in the list. Using with "count", you can retrieve long list of
files in chunks.
.TP
.B -l,--long
use long listing format. The displayed fields depend on the file type. In case of
.BR LFN
the fields are:
.B file mode,
.B number of links to the file,
.B user id,
.B group id,
.B file size (bytes),
.B file name.
In case of
.B SURL
the fields are:
.B file mode,
.B number of links to the file,
.B user id,
.B group id,
.B file size (bytes),
.B locality,
.B file name.
.TP
.B -d,--dir
does not list the directory contents, but shows information about the directory itself. This option is not compatible with Classic SEs.
.TP
.B -v,--verbose
Verbose mode. You can specify it twice for extra verbose mode.

.SH "NOTE"
The environment variable LCG_GFAL_INFOSYS must point to the BDII, unless
.I --nobdii
option is used.

.SH "EXAMPLE"
.nf
.ft CW
	lcg-ls srm://lxpdm101.cern.ch/dpm/cern.ch/home

	/dpm/cern.ch/home/alice
	/dpm/cern.ch/home/atlas
	/dpm/cern.ch/home/cms
	/dpm/cern.ch/home/dteam
	/dpm/cern.ch/home/gin
	/dpm/cern.ch/home/gin.ggf.org
	/dpm/cern.ch/home/lhcb
	/dpm/cern.ch/home/ops

.ft
.fi

.SH "EXIT STATUS"
This program returns 0 if the operation was successful or >0 if the operation
failed.

.SH "SEE ALSO"
.BR lcg-aa (1),
.BR lcg-cp (1),
.BR lcg-cr (1),
.BR lcg-del (1),
.BR lcg-getturls (1),
.BR lcg-gt (1),
.BR lcg-la (1),
.BR lcg-lg (1),
.BR lcg-lr (1),
.BR lcg-ra (1),
.BR lcg-rep (1),
.BR lcg-rf (1),
.BR lcg-sd (1),
.BR lcg-stmd (1),
.BR lcg-uf (1)
