.\" @(#)$RCSfile: lcg-sd.man,v $ $Revision: 1.10 $ $Date: 2009/11/19 13:58:41 $ CERN Jean-Philippe Baud
.\" Copyright (C) 2005 by CERN
.\" All rights reserved
.\"
.TH "LCG-SD" "1" "$Date: 2009/11/19 13:58:41 $" "LCG_UTIL" "User Commands"

.SH "NAME"
lcg-sd - set file status to "Done" for a given SURL in a specified request

.SH "SYNOPSIS"
.B lcg-sd
[
.B -h,--help
] [
.B -v,--verbose
] [
.B -b,--nobdii
] [
.B  --connect-timeout "timeout"
] [
.B  --sendreceive-timeout "timeout"
] [
.B  --bdii-timeout "timeout"
] [
.B  --srm-timeout "timeout"
] [
.B --version
]
.I surl
(
.I reqid fileid
|
.I reqtoken
)
.I oflag

.SH "DESCRIPTION"
.B lcg-sd
sets file status to "Done" for a given SURL in a specified request.
This is only meaningful if the space is managed by an SRM. If you specify a given command line option
multiple times, the command takes into account only the very last one so that in a script, you can
override a particular option in a pre-set option set (like gcc does).
.TP
.B --connect-timeout
Sets the connect timeout, used when connecting to a remote host. The connection will be aborted
if the remote host doesn't reply after
.I value
seconds. Default: 60 seconds.
.TP
.B --sendreceive-timeout
Sets the send/receive data timeout, used when transferring data to/from a remote host. The connection will be aborted
if no data is transfered after
.I value
seconds. Default: 0 (blocking).
.TP
.B --bdii-timeout
Sets the BDII timeout, used when searching information into BDII. The connection will be aborted
if the search is longer than
.I value
seconds. Default: 60 seconds.
.TP
.B --srm-timeout
Sets the SRM timeout, used when doing an asynchronous SRM request. The request will be aborted
if it is still queued after
.I value
seconds. Default: 3600 seconds (1 hour).
.TP
.I surl
specifies the Site URL. An SURL starts with
.BR srm: .
.TP
.I reqid
is the request identifier returned by
.BR lcg_gt
with SRMv1.
.TP
.I fileid
is the file ordinal returned by
.BR lcg_gt
with SRMv1.
.TP
.I reqtoken
is the token returned by
.BR lcg_gt
with SRMv2.
.TP
.I oflag
Ignored. Kept for syntax backward compatibility. Put '0' for example.
.TP
.B -b,--nobdii
If this flag is present, it means that you don't want to make BDII calls to get SE type. So, you must provide full endpoint in SURLs.
The SE type is deduced from argument list. If you specify
.I reqid
and
.I fileid
it is a SRMv1 endpoint. If you specify
.I reqtoken
it is a SRMv2 endpoint.
.TP
.B -v,--verbose
Verbose mode. You can specify it twice for extra verbose mode.

.SH "NOTE"
The environment variable LCG_GFAL_INFOSYS must point to the BDII, unless
.I --nobdii
option is used.

.SH "EXAMPLES"
.nf
.ft CW
	lcg-sd srm://lxshare0303.cern.ch:8443/castor/cern.ch/home/dteam/test \\
	939325759 0 0
	lcg-sd srm://lxshare0303.cern.ch:8443/castor/cern.ch/home/dteam/test \\
	9393-45453af 0
.ft
.fi

.SH "EXIT STATUS"
This program returns 0 if the operation was successful or >0 if the operation
failed.

.SH "SEE ALSO"
.BR lcg-aa (1),
.BR lcg-cp (1),
.BR lcg-cr (1),
.BR lcg-del (1),
.BR lcg-getturls (1),
.BR lcg-gt (1),
.BR lcg-la (1),
.BR lcg-lg (1),
.BR lcg-lr (1),
.BR lcg-ls (1),
.BR lcg-ra (1),
.BR lcg-rep (1),
.BR lcg-rf (1),
.BR lcg-sd (1),
.BR lcg-stmd (1),
.BR lcg-uf (1)
