.\" @(#)$RCSfile: lcg_del.man,v $ $Revision: 1.18 $ $Date: 2009/07/08 15:40:05 $ CERN Jean-Philippe Baud
.\" Copyright (C) 2005 by CERN
.\" All rights reserved
.\" 
.TH "LCG_DEL" "3" "$Date: 2009/07/08 15:40:05 $" "LCG_UTIL" "Library Functions"

.SH "NAME"
lcg_del - delete files (SURLs or LFNs)

.SH "SYNOPSIS"
\fB#include "lcg_util.h"\fR
.sp
.BI "int lcg_del (char *" file ,
.BI "int " aflag ,
.BI "char *" se ,
.BI "char *" vo ,
.BI "char *" conf_file ,
.BI "int " insecure ,
.BI "int " verbose );
.sp
.BI "int lcg_delt (char *" file ,
.BI "int " aflag ,
.BI "char *" se ,
.BI "char *" vo ,
.BI "char *" conf_file ,
.BI "int " insecure ,
.BI "int " verbose ,
.BI "int " timeout);
.sp
.BI "int lcg_delx (char *" file ,
.BI "int " aflag ,
.BI "char *" se ,
.BI "char *" vo ,
.BI "char *" conf_file ,
.BI "int " insecure ,
.BI "int " verbose ,
.BI "char *" errbuf ,
.BI "int " errbufsz );
.sp
.BI "int lcg_delxt (char *" file ,
.BI "int " aflag ,
.BI "char *" se ,
.BI "char *" vo ,
.BI "char *" conf_file ,
.BI "int " insecure ,
.BI "int " verbose ,
.BI "int " timeout ,
.BI "char *" errbuf ,
.BI "int " errbufsz );
.sp
.BI "int lcg_del3 (char *" file ,
.BI "enum se_type" defaulttype ,
.BI "enum se_type" setype ,
.BI "int " nobdii ,
.BI "int " aflag ,
.BI "char *" se ,
.BI "char *" vo ,
.BI "char *" conf_file ,
.BI "int " insecure ,
.BI "int " verbose ,
.BI "int " timeout ,
.BI "char *" errbuf ,
.BI "int " errbufsz );
.sp
.BI "int lcg_del4 (char *" file ,
.BI "enum se_type" defaulttype ,
.BI "enum se_type" setype ,
.BI "int " nobdii ,
.BI "int " nolfc ,
.BI "int " aflag ,
.BI "char *" se ,
.BI "char *" vo ,
.BI "char *" conf_file ,
.BI "int " insecure ,
.BI "int " verbose ,
.BI "int " timeout ,
.BI "char *" errbuf ,
.BI "int " errbufsz );
.sp
.BI "int lcg_del5 (int" nbfiles ,
.BI "char **" files ,
.BI "enum se_type" defaulttype ,
.BI "enum se_type" setype ,
.BI "int " nobdii ,
.BI "int " nolfc ,
.BI "int " aflag ,
.BI "char *" se ,
.BI "char *" vo ,
.BI "char *" conf_file ,
.BI "int " insecure ,
.BI "int " verbose ,
.BI "int " timeout ,
.BI "lcg_filestatus **" statuses ,
.BI "char *" errbuf ,
.BI "int " errbufsz );
.sp
.BI "int lcg_del6 (int" nbfiles ,
.BI "char **" files ,
.BI "enum se_type" defaulttype ,
.BI "enum se_type" setype ,
.BI "int " nobdii ,
.BI "int " nolfc ,
.BI "int " aflag ,
.BI "char *" se ,
.BI "char *" vo ,
.BI "char *" conf_file ,
.BI "int " insecure ,
.BI "int " verbose ,
.BI "int " bool_force ,
.BI "int " timeout ,
.BI "lcg_filestatus **" statuses ,
.BI "char *" errbuf ,
.BI "int " errbufsz );
.sp
.BI "int lcg_del7 (int" nbfiles ,
.BI "char **" files ,
.BI "enum se_type" defaulttype ,
.BI "enum se_type" setype ,
.BI "int " nobdii ,
.BI "int " nolfc ,
.BI "int " aflag ,
.BI "char *" se ,
.BI "char *" vo ,
.BI "char *" conf_file ,
.BI "int " insecure ,
.BI "int " verbose ,
.BI "int " bool_force ,
.BI "int " bool_rmdir ,
.BI "int " timeout ,
.BI "lcg_filestatus **" statuses ,
.BI "char *" errbuf ,
.BI "int " errbufsz );

.SH "DESCRIPTION"
.B lcg_del
deletes one file (either one replica or all replicas).
If it was the last or only valid replica, the entries corresponding to this
GUID are also removed from the RMC or the LFC.
.TP 
.I file
specifies the Logical File Name, the Grid Unique IDentifier or the Site URL.
An SURL scheme can be 
.B sfn:
for a classical SE or 
.BR srm: .
.TP 
.I nbfiles
specifies the number of elements in 
.BR files .
.TP
.I files
specifies a list of files of size 
.BR nbfiles .
.TP
.I defaulttype
specifies the default SE type you want to use. Possible values are
.BR TYPE_NONE ,
.BR TYPE_SE ,
.BR TYPE_SRM ,
.BR TYPE_SRMv2 ,
for respectively no default type, classic SE, SRMv1, and SRMv2. But if according to the BDII the default type
is not available for this SE, it will use another type.
.TP
.I setype
specifies the SE type you want to use for the source file. Possible values are
.BR TYPE_NONE ,
.BR TYPE_SE ,
.BR TYPE_SRM ,
.BR TYPE_SRMv2 ,
for respectively no type, classic SE, SRMv1, and SRMv2. But if according to the BDII the default type
is not available for this SE, it will fail.
.TP
.I nobdii
If set to a non-zero value, it means that you don't want to make BDII calls to get SE type. So, you must provide the type of the SE
for srm: arguments, and full endpoint in SURLs. For SE type,
.I defaulttype
can be used.
.TP
.I nolfc
If set to a non-zero value, it means that the SURL is not registered in any LFC server, and so you explicitely ask lcg_del to not
connect to the LFC server.
.TP 
.I aflag
An attempt is made to delete all replicas for the file specified as a GUID or LFN.
.TP 
.I se
Only the replica residing on
.I se
is deleted.
.TP 
.I vo
specifies the Virtual Organization the user belongs to. If it is not specified,
the environment variable LCG_GFAL_VO will be used.
.TP 
.I conf_file
This argument is currently ignored.
.TP 
.I insecure
This argument is currently ignored.
The access to the Replica Catalog or the LFC is done according to the endpoints published 
in MDSS while the access to the SE is always done in secure mode.
.TP 
.I bool_force
if non equals 0, then all errors during file deletion of file unregistration will be ignored.
The function will return 0, as if no errors happened.
Note that it means that files will be unregistered even if the function wasn't able to remove them,
so it may create some inconsistencies!
.TP 
.I bool_rmdir
if non equals 0, then it means that the user want to delete (empty) directory. Note that it is
possible to delete only one directory at a time.
.TP
.B verbose
Verbose level. Here are the possible levels:
.RS 
.TP 0.5i
.B 0
Only critical errors are displayed on stderr or put into errbuf if not null.
.TP
.B 1
Warnings are displayed on stderr as well as critical errors.
.TP
.B 2
Debug information is displayed as well as warnings and critical errors.
.RE
.TP 
.I timeout
specifies the value of timeout (default 0).
.TP
.I statuses
It is an out argument to show the status of each each file, with possibly an explanation.
So this is a pointer to a table of structures, which contains the following fields:
.RS
.RS
.TP 2i
.BI "char *" file
the file name 
.TP
.BI "int " status
the status of the file, which is a value of errno
.TP
.BI "char *" explanation
an explanation of this status (can be NULL)
.RE
.RE
.TP
.I errbuf
specifies a buffer of size
.I errbufsz
to receive detailed error messages. If this pointer is NULL, the message goes
to stderr. The pointer should not be NULL if the application is a daemon or is
multi\-threaded.

.SH "NOTE"
The environment variable LCG_GFAL_INFOSYS must point to the BDII, unless
.I nobdii
is set to a non-zero value.
To use the RLS as catalog instead of the LFC, the environment variable
LCG_CATALOG_TYPE must explicitely be set to "edg". By default, it is set to "lfc".

.SH "RETURN VALUE"
This routine returns 0 if the operation was successful or \-1 if the operation
failed. In the latter case,
.B errno
is set appropriately.

.SH "ERRORS"
.TP 1.3i
.B ENOENT
The named file does not exist.
.TP 
.B EACCES
Permission denied.
.TP 
.B EFAULT
.I file
or
.I vo
is an invalid pointer.
.TP 
.B ECOMM
Communication error.
.TP
.B ENAMETOOLONG
.I vo
is too long. 
.TP
.B EPROTONOSUPPORT
Access method not supported.

.SH "FILES"
.B /opt/lcg/include/lcg_util.h
.TP 
.B /opt/lcg/lib/liblcg_util.so

.SH "SEE ALSO"
.BR lcg_aa (3),
.BR lcg_cp (3),
.BR lcg_cr (3),
.BR lcg_del (3),
.BR lcg_gt (3),
.BR lcg_la (3),
.BR lcg_lg (3),
.BR lcg_lr (3),
.BR lcg_ra (3),
.BR lcg_rep (3),
.BR lcg_rf (3),
.BR lcg_sd (3),
.BR lcg_stmd (3),
.BR lcg_uf (3)
