.\" @(#)$RCSfile: lcg_rep.man,v $ $Revision: 1.18 $ $Date: 2009/11/18 15:20:28 $ CERN Jean-Philippe Baud
.\" Copyright (C) 2004-2006 by CERN
.\" All rights reserved
.\" 
.TH "LCG_REP" "3" "$Date: 2009/11/18 15:20:28 $" "LCG_UTIL" "Library Functions"

.SH "NAME"
lcg_rep \- copy a file from one Storage Element to another Storage Element and registers it in the LRC or the LFC

.SH "SYNOPSIS"
\fB#include "lcg_util.h"\fR
.sp
.BI "int lcg_rep (char *" src_file ,
.BI "char *" dest_file ,
.BI "char *" vo ,
.BI "char *" relative_path ,
.BI "int " nbstreams ,
.BI "char *" conf_file ,
.BI "int " insecure ,
.BI "int " verbose );
.sp
.BI "int lcg_rept (char *" src_file ,
.BI "char *" dest_file ,
.BI "char *" vo ,
.BI "char *" relative_path ,
.BI "int " nbstreams ,
.BI "char *" conf_file ,
.BI "int " insecure ,
.BI "int " verbose ,
.BI "int " timeout);
.sp
.BI "int lcg_repx (char *" src_file ,
.BI "char *" dest_file ,
.BI "char *" vo ,
.BI "char *" relative_path ,
.BI "int " nbstreams ,
.BI "char *" conf_file ,
.BI "int " insecure ,
.BI "int " verbose ,
.BI "char *" errbuf ,
.BI "int " errbufsz );
.sp
.BI "int lcg_repxt (char *" src_file ,
.BI "char *" dest_file ,
.BI "char *" vo ,
.BI "char *" relative_path ,
.BI "int " nbstreams ,
.BI "char *" conf_file ,
.BI "int " insecure ,
.BI "int " verbose ,
.BI "int " timeout ,
.BI "char *" errbuf ,
.BI "int " errbufsz );
.sp
.BI "int lcg_rep2 (char *" src_file ,
.BI "char *" dest_file ,
.BI "char *" vo ,
.BI "char *" relative_path ,
.BI "int " nbstreams ,
.BI "char *" conf_file ,
.BI "int " insecure ,
.BI "int " verbose ,
.BI "int " timeout ,
.BI "char *" src_spacetokendesc ,
.BI "char *" dest_spacetokendesc ,
.BI "char *" errbuf ,
.BI "int " errbufsz );
.sp
.BI "int lcg_rep3 (char *" src_file ,
.BI "char *" dest_file ,
.BI "enum se_type" defaulttype ,
.BI "enum se_type" srctype ,
.BI "enum se_type" dsttype ,
.BI "int " nobdii ,
.BI "char *" vo ,
.BI "char *" relative_path ,
.BI "int " nbstreams ,
.BI "char *" conf_file ,
.BI "int " insecure ,
.BI "int " verbose ,
.BI "int " timeout ,
.BI "char *" src_spacetokendesc ,
.BI "char *" dest_spacetokendesc ,
.BI "char **" actual_surl ,
.BI "char *" errbuf ,
.BI "int " errbufsz );
.sp
.BI "int lcg_rep4 (char *" src_file ,
.BI "char *" dest_file ,
.BI "enum se_type" defaulttype ,
.BI "enum se_type" srctype ,
.BI "enum se_type" dsttype ,
.BI "int " nobdii ,
.BI "char *" vo ,
.BI "char *" relative_path ,
.BI "int " nbstreams ,
.BI "char *" conf_file ,
.BI "int " insecure ,
.BI "int " verbose ,
.BI "int " timeout ,
.BI "char *" src_spacetokendesc ,
.BI "char *" dest_spacetokendesc ,
.BI "char **" actual_surl ,
.BI "enum gfal_cksm_type " cksmtype ,
.BI "char *" errbuf ,
.BI "int " errbufsz );

.sp
.BI "int lcg_rep5 (char *" src_file ,
.BI "char *" dest_file ,
.BI "enum se_type" defaulttype ,
.BI "enum se_type" srctype ,
.BI "enum se_type" dsttype ,
.BI "int " nobdii ,
.BI "char *" vo ,
.BI "char *" relative_path ,
.BI "int " nbstreams ,
.BI "char *" conf_file ,
.BI "int " insecure ,
.BI "int " verbose ,
.BI "int " timeout ,
.BI "char *" src_spacetokendesc ,
.BI "char *" dest_spacetokendesc ,
.BI "char **" actual_surl ,
.BI "enum gfal_cksm_type " cksmtype ,
.BI "char** " src_protocols , 
.BI "char** " dst_protocols ,
.BI "char *" errbuf ,
.BI "int " errbufsz );

.SH "DESCRIPTION"
.B lcg_rep
copies a file from one Storage Element to another Storage Element and registers
it in the LRC or the LFC.
.TP 
.I src_file
specifies the source file name: the protocol can be LFN, GUID or SURL.
An SURL scheme can be
.B sfn:
for a classical SE or
.BR srm: .
.TP 
.I dest_file
specifies the destination.
It can be the Storage Element fully qualified hostname or an SURL. In the latter
case, the scheme can be
.B sfn:
for a classical SE or
.BR srm: .
If only the fully qualified hostname is given, a filename is generated
in the same format as with the Replica Manager.
.TP 
.I relative_path
specifies the path relative to the SARoot for the given VO.
.TP 
.I nbstreams
specifies the number of parallel streams (default 1).
.TP
.I defaulttype
specifies the default SE type you want to use. Possible values are
.BR TYPE_NONE ,
.BR TYPE_SE ,
.BR TYPE_SRM ,
.BR TYPE_SRMv2 ,
for respectively no default type, classic SE, SRMv1, and SRMv2. But if according to the BDII the default type
is not available for this SE, it will use another type.
.TP
.I srctype
specifies the SE type you want to use for the source file. Possible values are
.BR TYPE_NONE ,
.BR TYPE_SE ,
.BR TYPE_SRM ,
.BR TYPE_SRMv2 ,
for respectively no type, classic SE, SRMv1, and SRMv2. But if according to the BDII the default type
is not available for this SE, it will fail.
.TP
.I dsttype
specifies the SE type you want to use for the destination file. Possible values are
.BR TYPE_NONE ,
.BR TYPE_SE ,
.BR TYPE_SRM ,
.BR TYPE_SRMv2 ,
for respectively no type, classic SE, SRMv1, and SRMv2. But if according to the BDII the default type
is not available for this SE, it will fail.
.TP
.I nobdii
If set to a non-zero value, it means that you don't want to make BDII calls to get SE type. So, you must provide the type of the SE
for srm: arguments, and full endpoint in SURLs. For SE type,
.I defaulttype
can be used (it will be used for both source and destination).
.TP 
.I timeout
specifies the value of timeout (default 0).
.TP
.B verbose
Verbose level. Here are the possible levels:
.RS 
.TP 0.5i
.B 0
Only critical errors are displayed on stderr or put into errbuf if not null.
.TP
.B 1
Warnings are displayed on stderr as well as critical errors.
.TP
.B 2
Debug information is displayed as well as warnings and critical errors.
.RE
.TP 
.I vo
specifies the Virtual Organization the user belongs to. If it is not
specified, the environment variable LCG_GFAL_VO will be used.
.TP 
.I conf_file
This argument is currently ignored.
.TP 
.I insecure
This argument is currently ignored.
The access to the Replica Catalog or the LFC is done according to the endpoints published
in MDS while the copy is always done in secure mode.
.TP 
.I cksmtype
is the checksum type (algorithm) to use. Possible values are:
.RS 
.TP 2.5i
.B GFAL_CKSM_NONE
No checksum verification 
.TP
.B GFAL_CKSM_CRC32
CRC32 algorithm will be used
.TP
.B GFAL_CKSM_ADLER32
Adler32 algorithm will be used
.TP
.B GFAL_CKSM_MD5
MD5 algorithm will be used
.TP
.B GFAL_CKSM_SHA1
SHA-1 algorithm will be used
.RE
.TP 
.I errbuf
specifies a buffer of size
.I errbufsz
to receive detailed error messages. If this pointer is NULL, the message goes
to stderr. The pointer should not be NULL if the application is a daemon or is
multi\-threaded.
.TP
.I src_spacetokendesc
specifies the space token to use with
.IR src_file .
Can be
.BR NULL .
.TP
.I dest_spacetokendesc
specifies the space token to use with
.IR dest_file .
Can be
.BR NULL .
.TP
.I actual_surl
is a pointer to a 
.B char*
variable. If not set to NULL, the actual SURL of the new replica will be stored in this variable.
.TP
.I src_protocols
The ordered list of source transfer protocols to help TURL construction. It must be a NULL-terminated
string array. If the parameter is NULL, then the 1-element list containing "gsiftp" is used.
If a SE does not support any of the listed protocols, errno will be set to EOPNOTSUPP. 
.TP
.I dst_protocols
The ordered list of destination transfer protocols to help TURL construction. It should be a NULL-terminated
string array. If the parameter is NULL, then the 1-element list containing "gsiftp" is used.
If a SE does not support any of the listed protocols, errno will be set to EOPNOTSUPP. 

.SH "NOTE"
The environment variable LCG_GFAL_INFOSYS must point to the BDII, unless
.I nobdii
is set to a non-zero value.
To use the RLS as catalog instead of the LFC, the environment variable
LCG_CATALOG_TYPE must explicitely be set to "edg". By default, it is set to "lfc".

.SH "RETURN VALUE"
This routine returns 0 if the operation was successful or \-1 if the
operation failed. In the latter case,
.B errno
is set appropriately.

.SH "ERRORS"
.TP 1.3i
.B ENOENT
The named file does not exist.
.TP 
.B EACCES
Permission denied.
.TP 
.B EFAULT
.IR src_file ,
.I dest_file
or
.I vo
is an invalid pointer.
.TP 
.B EINVAL
.I src_file
or
.I dest_file
has an invalid syntax.
.TP 
.B ECOMM
Communication error.
.TP
.B ENAMETOOLONG
.I vo
is too long.  
.TP
.B EPROTONOSUPPORT
Access method not supported.
.TP
.B EOPNOTSUPP
An operation is not supported. They may be: source or destination protocol list is not supported.

.SH "FILES"
.B /opt/lcg/include/lcg_util.h
.TP 
.B /opt/lcg/lib/liblcg_util.so

.SH "SEE ALSO"
.BR lcg_aa (3),
.BR lcg_cp (3),
.BR lcg_cr (3),
.BR lcg_del (3),
.BR lcg_gt (3),
.BR lcg_la (3),
.BR lcg_lg (3),
.BR lcg_lr (3),
.BR lcg_ra (3),
.BR lcg_rep (3),
.BR lcg_rf (3),
.BR lcg_sd (3),
.BR lcg_stmd (3),
.BR lcg_uf (3)
