/*
 * Authors: Todor Manev <todor.manev@cern.ch>
 *
 * Copyright (c) Members of the EGEE Collaboration. 2004.
 * See http://www.eu-egee.org/partners/ for details on the copyright holders.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Unit tests for Savannah bug #60991: [lcg_util] lcg-cp not appropriate error message
 * for existing LFN
 *
 * Test if the logic recognizes unknown protocols of wrongly formatted
 * protocol lists in the transfetParameters property of PrepareToGet.
 */
#include "lcg_util.h"
#include "lcg_unit_testsuite.h"

char * lcg_test__lcgutil_str_tolower()
{
    char str_lowercase_1[] = "asd";
    char str_lowercase_2[] = "asd";
    char str_uppercase[] = "ASD";
    int cmp = -1;

    /* lowercase string must be unchanged */
    lcgutil_str_tolower (str_lowercase_1);
    cmp = strcmp (str_lowercase_1, str_lowercase_2);
    LCG_TEST_EQUAL (0, cmp);

    /* uppercase must be converted */
    lcgutil_str_tolower (str_uppercase);
    cmp = strcmp (str_lowercase_1, str_uppercase);
    LCG_TEST_EQUAL (0, cmp);

    return 0x0;
}
